Subject: Re: Dynamic libraries do not work

From: Theo Gjaltema <[email-masked]>
Date: Fri, 27 May 2005 07:36:18 +0200

Grant Likely schreef:

>On 5/26/05, Theo Gjaltema <[email-masked]> wrote:
>  
>
>>Hello,
>>
>>I have a linux 2.4.20 kernel running, but the files in the ramdisk fail
>>to execute if they are dynamically build.
>>The whole system stops (debuggers shows that it crashed while in an erea
>>where no flash/ram is present.
>>Anyone an idea?
>>There is nog difference between the use of a ramdisk or an nfs mounted
>>root filesystem.
>>
>>    
>>
>More data please;  Make sure you attach actual output when asking for help.
>
>  
>
You are right, this gives too little info. Since the system stops 
without giving any data, I don't know what to attach
maybe:
RAM: 64 Mbyte

(using a static linked busybox: activating a sh (=busybox) b 
::sysinit:/bin/sh)
sh: /lib/ld.so.1
< help page of ld.so.1>
sh: /lib/ld.so.1 --verify /bin/xxx (or just any dynamic linked library)
<here the system has crahed>

or
sh: /bin/xxx
<here the system has crashed>

I have tried to step through the dynamic linking, but did not succeed 
til after the creation of a thread.
With a dynamic linked busybox the system stops after a message such as
"freeing xxx kbytes" (I don't know the actual number by head)
When init is then called, which is a part of the busybox which is dyn. 
liked, it crashes.

Greetings,
   Theo